using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using NestedHtmlWriter;
using MagSiteLib;

namespace MagSite
{
	/// <summary>
	/// List ̊Tv̐łB
	/// </summary>
	public class List : System.Web.UI.Page
	{
#if DISABLE_MODOF_REDIRECT
		private void writeContentsList( FullKeyword keyword, NhQuickDocument doc )
		{
			SectionDef def = SectionDefManager.GetSectionDef(keyword);
			//doc.B.WriteHxText(1,pageTitle);
			using( NhHx head = doc.B.CreateHx(1) )
			{
				head.WriteText(def.ContentsListTitle);
				using( NhSpan span = head.CreateSpan() )
				{
					span.WriteClassAttr("maintitle");
					span.WriteText(" y");
					span.WriteText(keyword.Keywords[keyword.Keywords.Length-1]);
					span.WriteText("z");
				}
			}

			ItemID [] list;
			if( keyword.IsNoKeyword() )
			{
				list = ItemListManager.ContentList.GetItemIDs();
			}
			else
			{
				list = ItemListManager.ContentList.GetItemIDs(keyword);
			}
			if( list.Length == 0 ) 
			{
				doc.B.WritePText("YRec͂܂B");
				return;
			}

			Array.Sort(list);

			int p = list.Length-1;
			using( NhTable table = doc.B.CreateTable() )
			{
				while( true )
				{
					if( p < 0 ) break;
					DateTime itemDateOnly = list[p].GetDateOnly();
					Item item = ItemListManager.ContentList.GetItem(list[p]);

					int count = ContentAccessRanking.GetTotalAccessRanking(keyword).GetCount(list[p]);
					WriteLib.WriteContentListTr(table,-1,itemDateOnly,DateTime.MinValue,
						item.Keyword,FileNames.Default,list[p],count,"total",string.Empty);

					p--;
				}
			}
		}
#endif

		private void Page_Load(object sender, System.EventArgs e)
		{
#if DISABLE_MODOF_REDIRECT
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request.Params);

			SectionDef def = SectionDefManager.GetSectionDef(keyword);

			string subTitle = keyword.Keywords[keyword.Keywords.Length-1];
			string pageTitle = def.ContentsListTitle + " " + "y" + subTitle + "z";

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output,  pageTitle, keyword ) )
			{
				writeContentsList( keyword, doc );

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteNormalFooter(doc.B,keyword);
			}
#else
			ModulaFRedirector.Redirect( Response, Request );
#endif
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
